Foreman - Feature #17228

Allow selecting a template used as global default for each kind
11/04/2016 10:56 AM - Marek Hulan

Status: Closed
Priority: Normal
Assignee: Ondrej Prazak
Category: Templates
Target version: 1.15.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1382008 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/4283,
https://github.com/theforeman/foreman/p
ull/4331
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1382008

Description of problem:
The 'PXELinux global default' is silently overwritten by the ugprade process.

[crash] root@li-1c-1578:~# hammer -c/opt/hoici/etc/sat6/hammer-hoici.yaml template dump —--name='PX

ELinux global default'
empty

running a seed tasks e.g. from installer

[crash] root@li-1c-1578:~# satellite-installer --scenario=satellite --verbose --upgrade
[ INFO 2016-10-05 13:28:32 verbose] Executing hooks in group pre_migrations

[ INFO 2016-10-05 13:28:32 verbose]

[ INFO 2016-10-05 13:28:32 verbose] Executing hooks in group boot
[ INFO 2016-10-05 13:28:32 verbose]

Upgrade Step: db_seed...

[ INFO 2016-10-05 13:34:27 verbose] Upgrade Step: db_seed...
Seeding /usr/share/foreman/db/seeds.d/03-auth_sources.rb

Seeding /usr/share/foreman/db/seeds.d/03-permissions.rb

Seeding /usr/share/foreman/db/seeds.d/03-roles.rb

Seeding /usr/share/foreman/db/seeds.d/04-admin.rb

Seeding /usr/share/foreman/db/seeds.d/05-taxonomies.rb

Seeding /usr/share/foreman/db/seeds.d/06-architectures.rb

Seeding /usr/share/foreman/db/seeds.d/07-provisioning_templates.rb
Seeding /usr/share/foreman/db/seeds.d/08-partition_tables.rb
Seeding /usr/share/foreman/db/seeds.d/10-installation_media.rb
Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.
Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.
.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.0.0
templates.rb

o O
o O

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.0.0.

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.0.0
tions.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.0.0.

w.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.0.0.

otification.rb

Seeding /usr/share/foreman/db/seeds.d/ll-smart_proxy_features.rb
Seeding /usr/share/foreman/db/seeds.d/13-compute_profiles.rb
Seeding /usr/share/foreman/db/seeds.d/15-bookmarks.rb
All hooks in group pre_migrations finished

All hooks in group boot finished

.80/db/seeds.
.80/db/seeds.

.80/db/seeds.

80/db/seeds.
.80/db/seeds.

80/db/seeds.

80/db/seeds.

d/101-locations.rb
d/102-organizations

d/103-provisioning_

d/104-proxy.rb
d/106-mail_notifica

d/107-enable_dynflo

d/108-ensure_sync_n
Seeding /usr/share/foreman/db/seeds.d/16-mail_notifications.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman-tasks-0.7.14.7/db/seeds.d/20-foreman_

tasks_permissions.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/redhat_access-1.0.13/db/seeds.d/200-update—in
sights-roles.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman_bootdisk-6.1.0.3/db/seeds.d/50-bootdi
sk_templates.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman_discovery-5.0.0.9/db/seeds.d/50_disco

very_templates.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman-tasks-0.7.14.7/db/seeds.d/60-dynflow_

proxy_feature.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman_remote_execution-0.3.0.12/db/seeds.d/
60-ssh_proxy_feature.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman_discovery-5.0.0.9/db/seeds.d/60_disco

very_proxy_feature.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman-tasks-0.7.14.7/db/seeds.d/61l-foreman_

tasks_bookmarks.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman_remote_execution-0.3.0.12/db/seeds.d/
70-job_templates.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.0.0.80/db/seeds.d/75-job_templates.
rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman_remote_execution-0.3.0.12/db/seeds.d/
90-bookmarks.rb

Seeding /opt/theforeman/tfm/root/usr/share/gems/gems/foreman_theme_satellite-0.1.28/db/seeds.d/990
- provisioning_templates.rb

[crash] root@li-1c-1578:~# hammer -c/opt/hoici/etc/sat6/hammer-hoici.yaml template dump —-name='PX
ELinux global default'

<%#

kind: PXELinux

name: PXELinux global default

%>

<%# This template has special name (do not change it) and it is used for booting unknown hosts. %>

DEFAULT menu

PROMPT O

MENU TITLE PXE Menu
TIMEOUT 200
TOTALTIMEOUT 6000
ONTIMEOUT local

LABEL local
MENU LABEL (local)
MENU DEFAULT
LOCALBOOT 0

LABEL discovery

MENU LABEL (discovery)

KERNEL boot/fdi-image-rhel_7-vmlinuz

APPEND initrd=boot/fdi-image-rhel_7-img rootflags=loop root=live:/fdi.iso rootfstype=auto ro
rd.live.image acpi=force rd.luks=0 rd.md=0 rd.dm=0 rd.lvm=0 rd.bootif=0 rd.neednet=0 nomodeset pro
xy.url=https://SATELLITE_CAPSULE_URL: 9090 proxy.type=proxy

IPAPPEND 2

<% for profile in @profiles -%>
LABEL <%= "#{profile[:template]} - #{profile[:hostgroup]}" %>

KERNEL <%= profile[:hostgroup].operatingsystem.kernel (profile[:hostgroup].architecture) %>
<% case profile[:hostgroup] .operatingsystem.pxe_type -%>
<% when 'kickstart' -%>

APPEND initrd=<%= profile[:hostgroup].operatingsystem.initrd(profile[:hostgroup].architecture
) %> ks=<%= default_template_url (profile[:template], profile[:hostgroup]) %> ksdevice=bootif netwo
rk kssendmac
<% when 'preseed' -%>

APPEND initrd=<%= profile[:hostgroup].operatingsystem.initrd(profile[:hostgroup].architecture
) %> interface=auto url=<%= default_template_url (profile[:template], profile[:hostgroup]) %> ramdi
sk_size=10800 root=/dev/rd/0 rw auto hostname=unassigned-hostname locale=<%= profile[:hostgroup].p
arams|['lang'] || 'en_US' %> console-setup/ask_detect=false console-setup/layout=USA console-setup/
variant=USA

<% end —-%>

Version-Release number of selected component (if applicable):
Reproducible with Foreman 1.13 and nightly

How reproducible:

Always

Steps to Reproduce:

1. Edit the 'PXELinux global default’

2. Dump the 'PXELinux global default' on the console
hammer template dump --name='"PXELinux global default'
3. Run rake db:seed

4. Dump the 'PXELinux global default' on the console
hammer template dump --name='"PXELinux global default'

Actual results:
Content is changed to the default

Expected results:

- Upgrade process shall have logging and history appending when it overwrites content

- User can choose what template will be used as PXELinux global default (the same for other kinds) so its modified version can be
kept separately and still being used.

Additional info:

There is a code that checks audit records for template but it only verifies if name was changed. The name of global templates are
hardcoded so users can't just clone the default template and add custom modifications because such clone would not be deployable.
Therefore we should allow user to change the hardcoded names.

We should probably also add audit log if content has changed so user can revert.

Related issues:
Related to Foreman - Feature #7484: Per-subnet PXELinux global default files New 09/17/2014
Related to Foreman - Bug #19677: Unable to edit localboot templates Closed 05/26/2017

Associated revisions

Revision bc600bd6 - 02/23/2017 06:58 AM - Ondiej Prazak
Fixes #17228 - Select templates as global defaults (#4283)
This should allow user to select templates that will be used

for building PXE Default on TFTP proxy. These templates will
not be updated from seeds during updates.

Revision c08844d0 - 02/24/2017 10:00 AM - Dominic Cleal
refs #17228 - modify, don't re-define existing constant
Prevents warnings during startup:

app/models/setting/provisioning.rb:9: warning: already initialized constant Setting::BLANK_ATTRS
app/models/setting.rb:13: warning: previous definition of BLANK_ATTRS was here

History

#1 - 11/04/2016 10:56 AM - Marek Hulan

- Subject changed from Allow selecting a template used as global default for each kind
to Allow selecting a template used as global default for each kind

- Category changed from TFTP to Settings

- Target version set to 115
#2 - 11/08/2016 03:31 AM - Dominic Cleal
- Related to Feature #7484: Per-subnet PXELinux global default files added

#3 - 11/08/2016 03:33 AM - Dominic Cleal

The text of this ticket is reporting a bug about how templates are being changed on seed, which is likely introduced by #15416, but the title doesn't
match. They should probably be filed separately, as the seed issue appears valid (settings/changing the template is related to #7484).

#4 - 11/08/2016 03:53 AM - Marek Hulan

That was intentional. The text of the ticket gives background why we need to make the name of template configurable, hence the ticket subject. | think
changing of the template was intentional, so this ticket does not aim to change that behavior. The #7484 asks for global template per subnet which |
think is advanced and even conflicts with global template functionality.

#5 - 11/08/2016 09:47 AM - Marek Hulan

- Target version changed from 115 to 1.4.4

#6 - 11/29/2016 08:54 AM - Marek Hulan

- Target version changed from 1.4.4 to 1.10.1

#7 - 01/03/2017 08:21 AM - Marek Hulan
- Target version changed from 1.10.1 to 1.10.2

#8 - 01/10/2017 08:28 AM - Marek Hulan
- Target version changed from 1.10.2to 1.11.2

#9 - 01/31/2017 04:17 AM - Ondfej Prazak

- Assignee set to Ondrej PraZzak

#10 - 02/09/2017 08:15 AM - Marek Hulan

- Target version changed from 1.11.2t0 1.11.4

#11 - 02/14/2017 07:42 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/4283 added

#12 - 02/21/2017 10:21 AM - Marek Hulan

- Target version changed from 1.11.4 to 1.12.1

#13 - 02/23/2017 07:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset bc600bd637d3aff9d7221aa3f28160882cbe5d98.

#14 - 02/23/2017 10:17 AM - Dominic Cleal
- Tracker changed from Bug to Feature
- Category changed from Settings to Templates

- translation missing: en.field_release set to 209

#15 - 02/24/2017 08:46 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/4331 added

#16 - 05/26/2017 04:42 AM - Dominic Cleal
- Related to Bug #19677: Unable to edit localboot templates added
